/*
 
 Made by Marcel Vlastuin, marcel@codecup.nl.
 Generator example for the game less (CodeCup 2017).
 For more information: www.codecup.org.
 This program is part of the Caia project for the CodeCup 2017.
 The code is "as it is".
 
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>

#define SRAND() gettimeofday(&tp_rand, NULL); es_rand=(long)tp_rand.tv_sec; em_rand=(long)tp_rand.tv_usec; srand(1000000*es_rand+em_rand)
#define RAND(x) (int)((float)(x)*(rand()/(RAND_MAX+1.0)))

static struct timeval tp_rand;
static long es_rand, em_rand;

void draai ( char *in, char *antwoord, int aantal )
{
  char temp[13];
  if ( aantal == 0 )
  {
    strcpy ( antwoord, in );
    return;
  }
  temp[0] = in[7];
  temp[1] = in[2];
  temp[2] = in[10];
  temp[3] = in[5];
  temp[4] = in[0];
  temp[5] = in[8];
  temp[6] = in[3];
  temp[7] = in[11];
  temp[8] = in[6];
  temp[9] = in[1];
  temp[10] = in[9];
  temp[11] = in[4];
  draai ( temp, antwoord, aantal - 1 );
}

int main ( void )
{
  int i, j, k, u, w;
  int teller;
  FILE *in, *uit;
  char kaarten[24][13];
  char resultaat[13];
  int bord[17][9];
  int volgorde[24];
  in = fopen ( "tiles.txt", "rt" );
  for ( i = 0; i < 24; ++i )
  {
    fscanf ( in, "%s", kaarten[i] );
  }
  for ( i = 0; i < 17; ++i )
  {
    for ( j = 0; j < 9; ++j )
    {
      bord[i][j] = 0;
    }
  }
  for ( i = 0; i < 24; ++i )
  {
    volgorde[i] = i;
  }
  SRAND ( );
  for ( i = 23; i > 0; --i )
  {
    u = RAND ( i + 1 );
    w = volgorde[i];
    volgorde[i] = volgorde[u];
    volgorde[u] = w;
  }
  teller = 0;
  for ( i = 0; i < 4; ++i )
  {
    for ( j = 0; j < 4; ++j )
    {
      u = RAND ( 4 );
      draai ( kaarten[volgorde[teller++]], resultaat, u );
      fprintf ( stderr, "%2d-%d\n", volgorde[teller - 1] + 1, u );
      for ( k = 0; k < 12; ++k )
      {
        switch ( k )
        {
        case 0:
          if ( resultaat[0] == '1' )
          {
            ++bord[4 * i][2 * j];
          }
          break;
        case 1:
          if ( resultaat[1] == '1' )
          {
            ++bord[4 * i][2 * j + 1];
          }
          break;
        case 2:
          if ( resultaat[2] == '1' )
          {
            ++bord[4 * i + 1][2 * j];
          }
          break;
        case 3:
          if ( resultaat[3] == '1' )
          {
            ++bord[4 * i + 1][2 * j + 1];
          }
          break;
        case 4:
          if ( resultaat[4] == '1' )
          {
            ++bord[4 * i + 1][2 * j + 2];
          }
          break;
        case 5:
          if ( resultaat[5] == '1' )
          {
            ++bord[4 * i + 2][2 * j];
          }
          break;
        case 6:
          if ( resultaat[6] == '1' )
          {
            ++bord[4 * i + 2][2 * j + 1];
          }
          break;
        case 7:
          if ( resultaat[7] == '1' )
          {
            ++bord[4 * i + 3][2 * j];
          }
          break;
        case 8:
          if ( resultaat[8] == '1' )
          {
            ++bord[4 * i + 3][2 * j + 1];
          }
          break;
        case 9:
          if ( resultaat[9] == '1' )
          {
            ++bord[4 * i + 3][2 * j + 2];
          }
          break;
        case 10:
          if ( resultaat[10] == '1' )
          {
            ++bord[4 * i + 4][2 * j];
          }
          break;
        case 11:
          if ( resultaat[11] == '1' )
          {
            ++bord[4 * i + 4][2 * j + 1];
          }
          break;
        default:
          break;
        }
      }
    }
  }
  fprintf ( stderr, "\n" );
  uit = fopen ( "board.txt", "wt" );
  for ( i = 1; i < 16; ++i )
  {
    if ( i % 2 )
    {
      for ( j = 1; j < 8; ++j )
      {
        fprintf ( stderr, "%d", bord[i][j] );
        fprintf ( uit, "%d", bord[i][j] );
      }
    }
    else
    {
      for ( j = 0; j < 8; ++j )
      {
        fprintf ( stderr, "%d", bord[i][j] );
        fprintf ( uit, "%d", bord[i][j] );
      }
    }
    fprintf ( stderr, "\n" );
  }
  return 0;
}